# %%
import pandas as pd
import numpy as np

import start

# %%
df = pd.read_csv(start.DATA_PATH + "codes_wide.csv")
# %% Create coder 1 df
# in_context_a column = coder 1 codes in weeks 1 and 3
coder1 = df[(df.week == 1) | (df.week == 3)][
    ["ID", "incontext_a", "week", "master", "move", "move_label"]
].rename(columns={"incontext_a": "code"})
coder1["context"] = "in"
# out_context_a column = coder 1 codes in weeks 2 and 4
coder1 = coder1.append(
    df[(df.week == 2) | (df.week == 4)][
        ["ID", "outcontext_a", "week", "master", "move", "move_label"]
    ].rename(columns={"outcontext_a": "code"})
)
coder1["context"] = np.where(coder1.context == "in", "in", "out")
coder1["coder"] = 1

# %% Create coder 2 df
# outcontext_a column = coder 2 in weeks 1 and 3
coder2 = df[(df.week == 1) | (df.week == 3)][
    ["ID", "outcontext_a", "week", "master", "move", "move_label"]
].rename(columns={"outcontext_a": "code"})
coder2["context"] = "out"
# incontext_a column = coder 2 in weeks 2 and 4
coder2 = coder2.append(
    df[(df.week == 2) | (df.week == 4)][
        ["ID", "incontext_a", "week", "master", "move", "move_label"]
    ].rename(columns={"incontext_a": "code"})
)
coder2["context"] = np.where(coder2.context == "out", "out", "in")
coder2["coder"] = 2

# %% Create coder 3 df
# incontext_a column = coder 3 in weeks 1 and 3
coder3 = df[(df.week == 1) | (df.week == 3)][
    ["ID", "incontext_b", "week", "master", "move", "move_label"]
].rename(columns={"incontext_b": "code"})
coder3["context"] = "in"
# outcontext_a column = coder 3 in weeks 2 and 4
coder3 = coder3.append(
    df[(df.week == 2) | (df.week == 4)][
        ["ID", "outcontext_b", "week", "master", "move", "move_label"]
    ].rename(columns={"outcontext_b": "code"})
)
coder3["context"] = np.where(coder3.context == "in", "in", "out")
coder3["coder"] = 3

# %% Create coder 4 df
# outcontext_b column = coder 4 in weeks 1 and 3
coder4 = df[(df.week == 1) | (df.week == 3)][
    ["ID", "outcontext_b", "week", "master", "move", "move_label"]
].rename(columns={"outcontext_b": "code"})
coder4["context"] = "out"
# incontext_b column = coder 4 in weeks 2 and 4
coder4 = coder4.append(
    df[(df.week == 2) | (df.week == 4)][
        ["ID", "incontext_b", "week", "master", "move", "move_label"]
    ].rename(columns={"incontext_b": "code"})
)
coder4["context"] = np.where(coder4.context == "out", "out", "in")
coder4["coder"] = 4

# %% Concatenate coder files
df_full = pd.concat([coder1, coder2, coder3, coder4])[
    ["ID", "week", "coder", "context", "move", "code", "master"]
]

df_full["precision"] = np.where(
    df_full.code == 1, 0, np.nan
)  # precision denominator = positive annotations
df_full["precision"] = np.where(
    (df_full.master == 1) & (df_full.code == 1), 1, df_full.precision
)

df_full["recall"] = np.where(
    df_full.master == 1, 0, np.nan
)  # recall denominator = postive master codes
df_full["recall"] = np.where(
    (df_full.master == 1) & (df_full.code == 1), 1, df_full.recall
)

df_full["accuracy"] = np.where(df_full.code == df_full.master, 1, 0)

df_full["in_context"] = np.where(df_full.context == "in", 1, 0)
df_full["simple_scheme"] = np.where(df_full.in_context == 0, 1, 0)

df_full.to_csv(start.DATA_PATH + "codes_long.csv", index=False)
