# %%
import pandas as pd
import numpy as np

import start

# %%
df = pd.read_csv(start.DATA_PATH + "codes_wide_followup.csv")

# %% Create coder dfs
coder1 = df[(df.week == 5) | (df.week == 7)][
    ["ID", "incontext_a", "week", "master", "move", "move_label"]
].rename(columns={"incontext_a": "code"})
coder1["context"] = "in"
coder1 = coder1.append(
    df[(df.week == 6) | (df.week == 8)][
        ["ID", "outcontext_a", "week", "master", "move", "move_label"]
    ].rename(columns={"outcontext_a": "code"})
)
coder1["context"] = np.where(coder1.context == "in", "in", "out")
coder1["coder"] = 1


coder2 = df[(df.week == 5) | (df.week == 7)][
    ["ID", "outcontext_a", "week", "master", "move", "move_label"]
].rename(columns={"outcontext_a": "code"})
coder2["context"] = "out"
coder2 = coder2.append(
    df[(df.week == 6) | (df.week == 8)][
        ["ID", "incontext_a", "week", "master", "move", "move_label"]
    ].rename(columns={"incontext_a": "code"})
)
coder2["context"] = np.where(coder2.context == "out", "out", "in")
coder2["coder"] = 2


coder3 = df[(df.week == 5) | (df.week == 7)][
    ["ID", "outcontext_b", "week", "master", "move", "move_label"]
].rename(columns={"outcontext_b": "code"})
coder3["context"] = "out"
coder3 = coder3.append(
    df[(df.week == 6) | (df.week == 8)][
        ["ID", "incontext_b", "week", "master", "move", "move_label"]
    ].rename(columns={"incontext_b": "code"})
)
coder3["context"] = np.where(coder3.context == "out", "out", "in")
coder3["coder"] = 3


df_full = pd.concat([coder1, coder2, coder3])[
    ["ID", "week", "coder", "context", "move", "code", "master"]
]

# %%
df_full["precision"] = np.where(df_full.code == 1, 0, np.nan)
df_full["precision"] = np.where(
    (df_full.master == 1) & (df_full.code == 1), 1, df_full.precision
)

df_full["recall"] = np.where(df_full.master == 1, 0, np.nan)
df_full["recall"] = np.where(
    (df_full.master == 1) & (df_full.code == 1), 1, df_full.recall
)

df_full["accuracy"] = np.where(df_full.code == df_full.master, 1, 0)

df_full["in_context"] = np.where(df_full.context == "in", 1, 0)
df_full["simple_scheme"] = np.where(df_full.in_context == 0, 1, 0)

df_full.to_csv(start.DATA_PATH + "codes_long_followup.csv", index=False)

# %%
