# %%

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
import start

time = pd.read_csv(start.DATA_PATH + "times_follow_up.csv")


# %%
label_list = [
    "Complex",
    "Out-of-Context",
    "Complex",
    "Out-of-Context",
    "Complex",
]

df = time.sort_values(by="week")
# df["week"] = np.where(df.coder != 1, df.week + 1, df.week)

plt.style.use("seaborn")
sns.set_style("whitegrid")
# %%

fig, ax = plt.subplots()

ax.plot(
    [1, 2, 3, 4],
    df[df.coder == 1].seconds_per_utterance,
    color="black",
    linestyle="solid",
    label="Annotator 1",
)


ax.plot(
    [2, 3, 4, 5],
    df[df.coder == 2].seconds_per_utterance,
    color="gray",
    linestyle="solid",
    label="Annotator 2",
)

ax.plot(
    [2, 3, 4, 5],
    df[df.coder == 3].seconds_per_utterance,
    color="gray",
    linestyle="dashed",
    label="Annotator 3",
)


plt.xlabel("Annotation Procedure")
plt.ylabel("Seconds")
# plt.ylim(0, 240)
plt.xticks([1, 2, 3, 4, 5], labels=label_list)
ax.legend()
# plt.yticks([0, 30, 60, 90, 120, 150, 180, 210, 240])
plt.savefig(start.RESULTS_PATH + "single_case_time_followup.eps")

print(df[df.context == "out"].seconds_per_utterance.mean())
print(df[df.context == "in"].seconds_per_utterance.mean())

# %%

# %%
time_in_context = df[df.context == "in"]

time_out_context = df[df.context == "out"]

print(time_in_context.seconds_per_10.mean())
print(time_out_context.seconds_per_10.mean())  # 113 min 54 seconds
print(time_out_context.seconds_per_10.mean() - time_in_context.seconds_per_10.mean())
# %%
coders2_and_3 = df[(df.coder == 2) | (df.coder == 3)]
time_in_context_2_3 = coders2_and_3[coders2_and_3.context == "in"]
time_out_context_2_3 = coders2_and_3[coders2_and_3.context == "out"]
print(time_in_context_2_3.seconds_per_10.mean() / 10)
print(time_out_context_2_3.seconds_per_10.mean() / 10)  # 113 min 54 seconds
print(
    time_in_context_2_3.seconds_per_10.mean() / 10
    - time_out_context_2_3.seconds_per_10.mean() / 10
)
# %%
