# %%
import pandas as pd
import numpy as np
import simpledorff


import start

# %%
df = pd.read_csv(start.DATA_PATH + "codes_wide.csv")

df["agree"] = np.where(df.master == df.master2, 1, 0)
print("Percent agreement ", round(df.agree.mean(), 2))

# %%
df["annotation_id"] = df["ID"].astype(str) + "_" + df["move"].astype(str)
master1 = df[["ID", "move", "annotation_id", "master"]].rename(
    columns={"master": "code"}
)
master1["annotator_id"] = 1
master2 = df[["ID", "move", "annotation_id", "master2"]].rename(
    columns={"master2": "code"}
)
master2["annotator_id"] = 2

df_long = master1.append(master2)

# %%
k = simpledorff.calculate_krippendorffs_alpha_for_df(
    df_long,
    experiment_col="annotation_id",
    annotator_col="annotator_id",
    class_col="code",
)
print("Krippendorf's alpha", round(k, 2))
# %%
